/* Generated by GOB (v2.0.11)   (do not edit directly) */



/***************************************************************************
                   lum-playlist.gob  -  Lumiere Playlist Window 
                             -------------------
    copyright            : (C) 2003,2004 by Stéphane Konstantaropoulos
    email                : stephanek@brutele.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
 * CVS block: cvs hosted at nongnu.org
 *
 * $Author: stephanek $
 * $Revision: 1.13 $
 * $Date: 2005/04/13 01:26:42 $
 *
 */

#include <glib.h>
#include <glib-object.h>
#ifndef __LUM_PLAYLIST_H__
#define __LUM_PLAYLIST_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include "lum-engine.h"
#include "lum-player-info.h"
#include "lum-shell.h"
#include <gtk/gtk.h>


typedef enum {
	COL_DISPLAY_URI,
	COL_ACTUAL_URI,
	COL_INFO,
	COL_NR
} LumPlaylistColumn;
#define LUM_TYPE_PLAYLIST_COLUMN lum_playlist_column_get_type()
GType lum_playlist_column_get_type (void);


/*
 * Type checking and casting macros
 */
#define LUM_TYPE_PLAYLIST	(lum_playlist_get_type())
#define LUM_PLAYLIST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), lum_playlist_get_type(), LumPlaylist)
#define LUM_PLAYLIST_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), lum_playlist_get_type(), LumPlaylist const)
#define LUM_PLAYLIST_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), lum_playlist_get_type(), LumPlaylistClass)
#define LUM_IS_PLAYLIST(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), lum_playlist_get_type ())

#define LUM_PLAYLIST_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), lum_playlist_get_type(), LumPlaylistClass)

/* Private structure type */
typedef struct _LumPlaylistPrivate LumPlaylistPrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_LUM_PLAYLIST__
#define __TYPEDEF_LUM_PLAYLIST__
typedef struct _LumPlaylist LumPlaylist;
#endif
struct _LumPlaylist {
	GtkWindow __parent__;
	/*< private >*/
	LumPlaylistPrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _LumPlaylistClass LumPlaylistClass;
struct _LumPlaylistClass {
	GtkWindowClass __parent__;
};


/*
 * Public methods
 */
GType	lum_playlist_get_type	(void);
LumPlaylist * 	lum_playlist_new	(LumEngine * engine);
void 	lum_playlist_add_list	(LumPlaylist * self,
					GList * uris,
					GList * infos);
void 	lum_playlist_add	(LumPlaylist * self,
					const gchar * uri,
					LumPlayerInfo * info);
LumPlayerInfo * 	lum_playlist_get_active_info	(LumPlaylist * self);
gchar * 	lum_playlist_get_active_uri	(LumPlaylist * self);
gint 	lum_playlist_get_length	(LumPlaylist * self);
GList * 	lum_playlist_get_list	(LumPlaylist * self);
void 	lum_playlist_clear	(LumPlaylist * self);
gboolean 	lum_playlist_has_next	(LumPlaylist * self);
void 	lum_playlist_next	(LumPlaylist * self);
gboolean 	lum_playlist_has_prev	(LumPlaylist * self);
void 	lum_playlist_prev	(LumPlaylist * self);
void 	lum_playlist_set_at_start	(LumPlaylist * self);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
