/* Generated by GOB (v2.0.11)   (do not edit directly) */



/***************************************************************************
                          lum-skin.gob  -  Lumiere Main Window 
                             -------------------
    begin                : lun oct 12 02:08:47 BST 2003
    copyright            : (C) 2003 by Stphane Konstantaropoulos
    email                : stephanek@brutele.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <glib.h>
#include <glib-object.h>
#ifndef __LUM_SKIN_H__
#define __LUM_SKIN_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include "lum-engine.h"
#include "lum-shell.h"
#include <gtk/gtk.h>
#include <stdbool.h>

typedef struct
{
	GdkPixmap *pixmap, *def_pixmap;
	/* The real size of the pixmap */
	gint width, height;
	/* The size of the pixmap from the current skin,
	   which might be smaller */
	gint current_width, current_height;
} LumSkinPixmap;




typedef enum {
	SKIN_MAIN,
	SKIN_CBUTTONS,
	SKIN_TITLEBAR,
	SKIN_SHUFREP,
	SKIN_TEXT,
	SKIN_VOLUME,
	SKIN_BALANCE,
	SKIN_MONOSTEREO,
	SKIN_PLAYPAUSE,
	SKIN_NUMBERS,
	SKIN_POSBAR,
	SKIN_NONE
} LumSkinIndex;
#define LUM_TYPE_SKIN_INDEX lum_skin_index_get_type()
GType lum_skin_index_get_type (void);


typedef enum {
	SKIN_MASK_MAIN,
	SKIN_MASK_EQ
} LumSkinMaskIndex;
#define LUM_TYPE_SKIN_MASKINDEX lum_skin_maskindex_get_type()
GType lum_skin_maskindex_get_type (void);


typedef enum {
	SKIN_PLEDIT_NORMAL,
	SKIN_PLEDIT_CURRENT,
	SKIN_PLEDIT_NORMALBG,
	SKIN_PLEDIT_SELECTEDBG,
	SKIN_TEXTBG,
	SKIN_TEXTFG,
	SKIN_COLORID_LAST
} LumSkinColorIndex;
#define LUM_TYPE_SKIN_COLORINDEX lum_skin_colorindex_get_type()
GType lum_skin_colorindex_get_type (void);


/*
 * Type checking and casting macros
 */
#define LUM_TYPE_SKIN	(lum_skin_get_type())
#define LUM_SKIN(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), lum_skin_get_type(), LumSkin)
#define LUM_SKIN_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), lum_skin_get_type(), LumSkin const)
#define LUM_SKIN_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), lum_skin_get_type(), LumSkinClass)
#define LUM_IS_SKIN(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), lum_skin_get_type ())

#define LUM_SKIN_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), lum_skin_get_type(), LumSkinClass)

/* Private structure type */
typedef struct _LumSkinPrivate LumSkinPrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_LUM_SKIN__
#define __TYPEDEF_LUM_SKIN__
typedef struct _LumSkin LumSkin;
#endif
struct _LumSkin {
	GtkWindow __parent__;
	/*< public >*/
	GdkGC * gc;
	GdkPixmap * bg;
	GdkPixmap * bg_ds;
	/*< private >*/
	LumSkinPrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _LumSkinClass LumSkinClass;
struct _LumSkinClass {
	GtkWindowClass __parent__;
	GdkPixmap * def_pixmaps[SKIN_NONE];
};


/*
 * Public methods
 */
GType	lum_skin_get_type	(void);
LumSkin * 	lum_skin_new	(LumEngine * engine);
bool 	lum_skin_get_shaded	(LumSkin * self);
void 	lum_skin_set_shaded	(LumSkin * self,
					bool shaded);
bool 	lum_skin_get_always_on_top	(LumSkin * self);
void 	lum_skin_set_always_on_top	(LumSkin * self,
					bool top);
GdkColor * 	lum_skin_get_skin_color	(LumSkin * self,
					LumSkinColorIndex si);
void 	lum_skin_set_info_text	(LumSkin * self,
					const char * text);
void 	lum_skin_set_info_text_temp	(LumSkin * self,
					const char * text);
void 	lum_skin_set_time	(LumSkin * self,
					int min,
					int secs);
void 	lum_skin_set_position	(LumSkin * self,
					gint position);
void 	lum_skin_set_volume	(LumSkin * self,
					gdouble position);
bool 	lum_skin_get_doublesize	(LumSkin * self);
void 	lum_skin_set_doublesize	(LumSkin * self,
					bool doublesize);
bool 	lum_skin_handle_event	(LumSkin * self,
					LumEngineEvent event,
					gpointer data);
GdkImage * 	lum_skin_get_doublesize_img	(GdkImage * img);

/*
 * Argument wrapping macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define LUM_SKIN_PROP_ENGINE(arg)    	"engine", __extension__ ({gpointer z = (arg); z;})
#define LUM_SKIN_GET_PROP_ENGINE(arg)	"engine", __extension__ ({gpointer *z = (arg); z;})
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define LUM_SKIN_PROP_ENGINE(arg)    	"engine",(gpointer )(arg)
#define LUM_SKIN_GET_PROP_ENGINE(arg)	"engine",(gpointer *)(arg)
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
